#ifndef MAT2_1_HPP
#define MAT2_1_HPP

#include <cmath>
#include <iostream>
using namespace std;


class mat2 {
protected:
 double mat[2][2];
public:
  mat2 (){cout<< " constructeur par défaut mat2"<<endl;}
  mat2 (double a11, double a12, double a21, double a22){
    mat[0][0]=a11;    mat[0][1]=a12;
    mat[1][0]=a21;    mat[1][1]=a22;
    cout<< " constructeur  mat2"<<endl;
  }
  mat2 (const mat2 & x){
    mat[0][0]=x.mat[0][0];	mat[0][1]=x.mat[0][1];
    mat[1][0]=x.mat[1][0];      mat[1][1]=x.mat[1][1];
    cout<< " constructeur par copie mat2"<<endl;
  }
  ~mat2 (){cout<< " destructeur mat2"<<endl;}

  void multiplie(double);
  friend ostream & operator << (ostream &,const mat2 &);
};

class vec2 {
protected:
 double vec[2];
public:
  vec2 (){cout<< " constructeur par défaut vec2"<<endl;};
  vec2 (double a1, double a2) {
    vec[0]=a1;	
    vec[1]=a2;
    cout<< " constructeur vec2"<<endl;
  }
  vec2 (const vec2 & x){
    vec[0]=x.vec[0];	
    vec[1]=x.vec[1];
    cout<< " constructeur par copie vec2"<<endl;
  }
  ~vec2 (){cout<<" destructeur vec2"<<endl;}

  void multiplie(double);
  friend ostream & operator << (ostream &,const vec2 &);
};

class matvec2 : public mat2, public vec2 {
protected:
 double vec[2];
public:
  matvec2 (){};
  matvec2 (double a11, double a12, double a21, double a22, double b1, double b2) : mat2(a11,a12,a21,a22), vec2(b1,b2) {
    cout<< " constructeur matvec2"<<endl;
  }
  matvec2 (const matvec2 & x) : mat2(x), vec2(x){
    cout<< " constructeur par copie vec2"<<endl;
  }
  ~matvec2 (){cout<<" destructeur matvec2"<<endl;};

  void multiplie(double);
  friend ostream & operator << (ostream &,const matvec2 &);
};



#endif
