#include <cmath>
#include <iostream>   
#include "groupea.hpp"

using namespace std;


bool groupea::certifie_associativite(groupea * a, groupea * b, groupea * c){
   bool resbool=false;

   this->addition(a,b);
   this->addition(this,c);
   b->addition(b,c);
   a->addition(a,b);
   resbool = this->equal(a); 
   return resbool;
}

bool groupea::certifie_neutre(groupea * a, groupea *b){
   bool resbool=false;

   a->zero();
   this->addition(b,a);
   resbool = this->equal(b); 
   return resbool;
}

bool groupea::certifie_oppose(groupea * a, groupea * b){
   bool resbool=false;

   b->oppose(this);
   a->zero();
   this->addition(this,b);
   resbool = this->equal(a); 
   return resbool;
}



mat2 mat2::operator + (mat2 x){
  mat2 res;
   res.addition(this,&x);
   return res;
   cout<<"+ de mat2"<<endl;
}
mat2 mat2::operator - (mat2 x){
  mat2 res,op;
   op.oppose(&x);
   res.addition(this,&op);
   return res;
   cout<<"- de mat2"<<endl;
}

bool mat2::equal (groupea * x){
  bool res=false;
  int c = 0;
  mat2 * p = dynamic_cast <mat2 *> (x);
  res=(mat[0][0] ==p->mat[0][0]);
  c = c + res;
  res=(mat[0][1] ==p->mat[0][1]);
  c = c + res;
  res=(mat[1][0] ==p->mat[1][0]);
  c = c + res;
  res=(mat[1][1] ==p->mat[1][1]);
  c = c + res;	

  res = false;
  cout<<"== de mat2"<<endl;
  if (c==4) {res= true;}
   return res;
}

mat2 & mat2::operator = (const mat2 & x){
   mat[0][0]=x.mat[0][0];	
   mat[0][1]=x.mat[0][1];
   mat[1][0]=x.mat[1][0];
   mat[1][1]=x.mat[1][1];
   return *this;
   cout<<"= du sous groupe"<<endl;
}

void mat2::oppose(groupea * x){
    mat2 * p = dynamic_cast <mat2 *> (x);	
    mat[0][0] =-p->mat[0][0];	
    mat[0][1] =-p->mat[0][1];
    mat[1][0] =-p->mat[1][0];
    mat[1][1] =-p->mat[1][1];
    cout<< "oppose5 mat2 "<<endl;
}

void mat2::zero(){
    mat[0][0] = 0.0;	
    mat[1][0] = 0.0;
    mat[0][1] = 0.0;
    mat[1][1] = 0.0;
    cout<<" zero du mat2"<<endl;
}

void mat2::addition (groupea * x1, groupea *x2){
   mat2 * p1 = dynamic_cast <mat2 *> (x1);
   mat2 * p2 = dynamic_cast <mat2 *> (x2);
   mat[0][0]= p1->mat[0][0] + p2->mat[0][0];	
   mat[0][1]= p1->mat[0][1] + p2->mat[0][1];
   mat[1][0]= p1->mat[1][0] + p2->mat[1][0];
   mat[1][1]= p1->mat[1][1] + p2->mat[1][1];
   cout<<"addition de mat2"<<endl;
  
}

ostream & operator <<(ostream & out, const mat2 & x){
   cout<<" A = {"<<x.mat[0][0]<<", "<<x.mat[0][1]<<", "<<x.mat[1][0]<<", "<<x.mat[1][1]<<" }"<<endl;
}
