#ifndef MAT2_1_HPP
#define MAT2_1_HPP

#include <cmath>
#include <iostream>
using namespace std;

class vec2 {
  friend class mat2;
  friend class ts2;
  friend class sym2;
  double vec[2];
public:
  vec2 (){cout<< " constructeur par défaut vec2"<<endl;};
  vec2 (double a1, double a2) {
    vec[0]=a1;	
    vec[1]=a2;
    cout<< " constructeur vec2"<<endl;
  }
  vec2 (const vec2 & x){
    vec[0]=x.vec[0];	
    vec[1]=x.vec[1];
    cout<< " constructeur par copie vec2"<<endl;
  }
  ~vec2 (){cout<<" destructeur vec2"<<endl;}
  
  friend ostream & operator << (ostream &,const vec2 &);
};

class mat2 {
protected:
 double mat[2][2];
public:
  mat2 (){cout<< " constructeur par défaut mat2"<<endl;}
  mat2 (double a11, double a12, double a21, double a22){
    mat[0][0]=a11;  mat[0][1]=a12;
    mat[1][0]=a21;  mat[1][1]=a22;
    cout<< " constructeur mat2"<<endl;
  }
  mat2 (const mat2 & x){
    mat[0][0]=x.mat[0][0]; mat[0][1]=x.mat[0][1];
    mat[1][0]=x.mat[1][0]; mat[1][1]=x.mat[1][1];
    cout<< " constructeur par copie mat2"<<endl;
  }
  ~mat2 (){cout<< " destructeur mat2"<<endl;}

  vec2 produitAb(vec2);
  friend ostream & operator << (ostream & out,const mat2 & x);
};

class ts2: public virtual mat2 {
public:
  ts2 (){cout<< " constructeur par défaut ts2"<<endl;}
  ts2 (double a11, double a12, double a22) : mat2(a11,a12,0.0,a22) {
    cout<< " constructeur  ts2"<<endl;
  }
  ts2 (const ts2 & x): mat2(x){
    cout<< " constructeur par copie ts2"<<endl;
  }
  ~ts2 (){cout<< " destructeur ts2"<<endl;}

  vec2 produitAb(vec2);
  friend ostream & operator << (ostream &,const ts2 &);
};


class sym2: public virtual mat2 {
public:
  sym2 (){cout<< " constructeur par défaut sym2"<<endl;}
  sym2 (double a11, double a21, double a22) : mat2(a11,a21,a21,a22) {
    cout<< " constructeur  sym2"<<endl;
  }
  sym2 (const sym2 & x): mat2(x){
    cout<< " constructeur par copie sym2"<<endl;
  }
  ~sym2 (){cout<< " destructeur sym2"<<endl;}

  vec2 produitAb(vec2);
  friend ostream & operator << (ostream &,const sym2 &);
};

 class d2: public ts2, public sym2 {
 public:
   d2 (){cout<< " constructeur par défaut d2"<<endl;}
   d2 (double a11, double a22) : mat2(a11,0.0,0.0,a22) {
     cout<< " constructeur d2"<<endl;
   }
   d2 (const d2 & x): mat2(x){
     cout<< " constructeur par copie d2"<<endl;
   }
   ~d2 (){cout<< " destructeur d2"<<endl;}

   vec2 produitAb(vec2);
   friend ostream & operator << (ostream & out,const d2 & x){
    out<<x.mat[0][0]<<" "<<x.mat[0][1]<<" "<<x.mat[1][0]<<" "<<x.mat[1][1]<<endl;
    return out;
  }
 };







#endif
